diff -Naur tomato/release/src/router/pptp-client/util.c tomato121/release/src/router/pptp-client/util.c
--- tomato/release/src/router/pptp-client/util.c	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/util.c	2008-10-12 14:45:41.000000000 +1100
@@ -1,7 +1,7 @@
 /* util.c ....... error message utilities.
  *                C. Scott Ananian <cananian@alumni.princeton.edu>
  *
- * $Id: util.c,v 1.1.1.1 2002/07/25 06:52:39 honor Exp $
+ * $Id: util.c,v 1.10 2005/03/10 01:18:20 quozl Exp $
  */
 
 #include <stdio.h>
@@ -15,39 +15,144 @@
 #define PROGRAM_NAME "pptp"
 #endif
 
+/* implementation of log_string, defined as extern in util.h */
+char *log_string = "pptp-client";
+
 static void open_log(void) __attribute__ ((constructor));
 static void close_log(void) __attribute__ ((destructor));
 
-static void open_log(void) {
-  openlog(PROGRAM_NAME, LOG_PID, LOG_DAEMON);
-}
-static void close_log(void) {
-  closelog();
-}
-
 #define MAKE_STRING(label) 				\
 va_list ap;						\
 char buf[256], string[256];				\
 va_start(ap, format);					\
 vsnprintf(buf, sizeof(buf), format, ap);		\
-snprintf(string, sizeof(string), "%s[%s:%s:%d]: %s",	\
-	 label, func, file, line, buf);			\
+snprintf(string, sizeof(string), "%s %s[%s:%s:%d]: %s",	\
+	 log_string, label, func, file, line, buf);	\
 va_end(ap)
 
-void _log(char *func, char *file, int line, char *format, ...) {
-  MAKE_STRING("log");
-  syslog(LOG_NOTICE, "%s", string);
-}
-
-void _warn(char *func, char *file, int line, char *format, ...) {
-  MAKE_STRING("warn");
-  fprintf(stderr, "%s\n", string);
-  syslog(LOG_NOTICE, "%s", string);
-}
-
-void _fatal(char *func, char *file, int line, char *format, ...) {
-  MAKE_STRING("fatal");
-  fprintf(stderr, "%s\n", string);
-  syslog(LOG_NOTICE, "%s", string);
-  exit(1);
+/*** open log *****************************************************************/
+static void open_log(void) {
+    openlog(PROGRAM_NAME, LOG_PID, LOG_DAEMON);
+}
+
+/*** close log ****************************************************************/
+static void close_log(void)
+{
+    closelog();
+}
+
+/*** print a message to syslog ************************************************/
+void _log(const char *func, const char *file, int line, const char *format, ...)
+{
+    MAKE_STRING("log");
+    syslog(LOG_NOTICE, "%s", string);
+}
+
+/*** print a warning to syslog ************************************************/
+void _warn(const char *func, const char *file, int line, const char *format, ...)
+{
+    MAKE_STRING("warn");
+//    fprintf(stderr, "%s\n", string);
+    syslog(LOG_WARNING, "%s", string);
+}
+
+/*** print a fatal warning to syslog and exit *********************************/
+void _fatal(const char *func, const char *file, int line, const char *format, ...)
+{
+    MAKE_STRING("fatal");
+//    fprintf(stderr, "%s\n", string);
+    syslog(LOG_CRIT, "%s", string);
+    exit(1);
+}
+
+/*** connect a file to a file descriptor **************************************/
+int file2fd(const char *path, const char *mode, int fd)
+{
+    int ok = 0;
+    FILE *file = NULL;
+    file = fopen(path, mode);
+    if (file != NULL && dup2(fileno(file), fd) != -1)
+        ok = 1;
+    if (file) fclose(file);
+    return ok;
 }
+
+/* signal to pipe delivery implementation */
+#include <unistd.h>
+#include <fcntl.h>
+#include <signal.h>
+#include <string.h>
+
+/* pipe private to process */
+static int sigpipe[2];
+
+/* create a signal pipe, returns 0 for success, -1 with errno for failure */
+int sigpipe_create()
+{
+  int rc;
+  
+  rc = pipe(sigpipe);
+  if (rc < 0) return rc;
+  
+  fcntl(sigpipe[0], F_SETFD, FD_CLOEXEC);
+  fcntl(sigpipe[1], F_SETFD, FD_CLOEXEC);
+  
+#ifdef O_NONBLOCK
+#define FLAG_TO_SET O_NONBLOCK
+#else
+#ifdef SYSV
+#define FLAG_TO_SET O_NDELAY
+#else /* BSD */
+#define FLAG_TO_SET FNDELAY
+#endif
+#endif
+  
+  rc = fcntl(sigpipe[1], F_GETFL);
+  if (rc != -1)
+    rc = fcntl(sigpipe[1], F_SETFL, rc | FLAG_TO_SET);
+  if (rc < 0) return rc;
+  return 0;
+#undef FLAG_TO_SET
+}
+
+/* generic handler for signals, writes signal number to pipe */
+void sigpipe_handler(int signum)
+{
+  write(sigpipe[1], &signum, sizeof(signum));
+  signal(signum, sigpipe_handler);
+}
+
+/* assign a signal number to the pipe */
+void sigpipe_assign(int signum)
+{
+  sigset_t sigset;
+  struct sigaction sa;
+
+  sigemptyset(&sigset);
+  sigaddset(&sigset, signum);
+  
+  memset(&sa, 0, sizeof(sa));
+  sa.sa_handler = sigpipe_handler;
+  sigaction(signum, &sa, NULL);
+}
+
+/* return the signal pipe read file descriptor for select(2) */
+int sigpipe_fd()
+{
+  return sigpipe[0];
+}
+
+/* read and return the pending signal from the pipe */
+int sigpipe_read()
+{
+  int signum;
+  read(sigpipe[0], &signum, sizeof(signum));
+  return signum;
+}
+
+void sigpipe_close()
+{
+  close(sigpipe[0]);
+  close(sigpipe[1]);
+}
+
diff -Naur tomato/release/src/router/pptp-client/util.h tomato121/release/src/router/pptp-client/util.h
--- tomato/release/src/router/pptp-client/util.h	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/util.h	2008-04-22 21:44:06.000000000 +1000
@@ -1,17 +1,26 @@
 /* util.h ....... error message utilities.
  *                C. Scott Ananian <cananian@alumni.princeton.edu>
  *
- * $Id: util.h,v 1.1.1.1 2002/07/25 06:52:39 honor Exp $
+ * $Id: util.h,v 1.6 2005/03/10 01:18:20 quozl Exp $
  */
 
 #ifndef INC_UTIL_H
 #define INC_UTIL_H
 
-void _log(char *func, char *file, int line, char *format, ...)
+/* log_string is an identifier for this pptp process, passed from
+   command line using --log-string=X, and included with every log message.
+   Useful for people with multiple pptp sessions open at a time */
+extern char * log_string;
+
+/* log_level sets the logging verbosity. Values range from 0 (errors only)
+   to 1 (errors and warnings) to 2 (high verbosity, for debugging) */
+extern int    log_level;
+
+void _log(const char *func, const char *file, int line, const char *format, ...)
      __attribute__ ((format (printf, 4, 5)));
-void _warn(char *func, char *file, int line, char *format, ...)
+void _warn(const char *func, const char *file, int line, const char *format, ...)
      __attribute__ ((format (printf, 4, 5)));
-void _fatal(char *func, char *file, int line, char *format, ...)
+void _fatal(const char *func, const char *file, int line, const char *format, ...)
      __attribute__ ((format (printf, 4, 5))) __attribute__ ((noreturn));
 
 #define log(format, args...) \
@@ -21,4 +30,25 @@
 #define fatal(format, args...) \
 	_fatal(__FUNCTION__,__FILE__,__LINE__, format , ## args)
 
+int file2fd(const char *path, const char *mode, int fd);
+
+/* signal to pipe delivery implementation */
+
+/* create a signal pipe, returns 0 for success, -1 with errno for failure */
+int sigpipe_create();
+
+/* generic handler for signals, writes signal number to pipe */
+void sigpipe_handler(int signum);
+
+/* assign a signal number to the pipe */
+void sigpipe_assign(int signum);
+
+/* return the signal pipe read file descriptor for select(2) */
+int sigpipe_fd();
+
+/* read and return the pending signal from the pipe */
+int sigpipe_read();
+
+void sigpipe_close();
+
 #endif /* INC_UTIL_H */
diff -Naur tomato/release/src/router/pptp-client/vector.c tomato121/release/src/router/pptp-client/vector.c
--- tomato/release/src/router/pptp-client/vector.c	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/vector.c	2008-04-22 21:44:06.000000000 +1000
@@ -2,7 +2,7 @@
  *                efficiently.
  *                C. Scott Ananian <cananian@alumni.princeton.edu>
  *
- * $Id: vector.c,v 1.1.1.1 2002/07/25 06:52:39 honor Exp $
+ * $Id: vector.c,v 1.3 2003/06/17 10:12:55 reink Exp $
  */
 
 #include <stdlib.h>
@@ -10,9 +10,7 @@
 #include <assert.h>
 #include "pptp_ctrl.h"
 #include "vector.h"
-
 /* #define VECTOR_DEBUG */
-
 #ifndef TRUE
 #define TRUE 1
 #endif
@@ -21,127 +19,141 @@
 #endif
 
 struct vector_item {
-  int key;
-  PPTP_CALL *call;
+    int key;
+    PPTP_CALL *call;
 };
+
 struct vector_struct {
-  struct vector_item *item;
-  int size;
-  int alloc;
-  
+    struct vector_item *item;
+    int size;
+    int alloc;
 #ifdef VECTOR_DEBUG
-  int key_max;
+    int key_max;
 #endif
 };
 
 static struct vector_item *binary_search(VECTOR *v, int key);
 
-VECTOR *vector_create() {
-  const int INITIAL_SIZE = 4;
-
-  VECTOR *v = malloc(sizeof(*v));
-  if (v==NULL) return v;
-
-  v->size = 0;
-  v->alloc= INITIAL_SIZE;
-  v->item = malloc(sizeof(*(v->item))*(v->alloc));
-
+/*** vector_create ************************************************************/
+VECTOR *vector_create()
+{
+    const int INITIAL_SIZE = 4;
+
+    VECTOR *v = malloc(sizeof(*v));
+    if (v == NULL) return v;
+
+    v->size = 0;
+    v->alloc = INITIAL_SIZE;
+    v->item = malloc(sizeof(*(v->item)) * (v->alloc));
 #ifdef VECTOR_DEBUG
-  v->key_max=-1;
+    v->key_max = -1;
 #endif
-
-  if (v->item == NULL) { free(v); return NULL; }
-  else return v;
+    if (v->item == NULL) { free(v); return NULL; }
+    else return v;
 }
 
-void vector_destroy(VECTOR *v) {
-  free(v->item);
+/*** vector_destroy ***********************************************************/
+void vector_destroy(VECTOR *v)
+{
+    free(v->item);
 #ifdef VECTOR_DEBUG
-  v->item = NULL;
+    v->item = NULL;
 #endif
-  free(v);
+    free(v);
 }
 
-int vector_size(VECTOR *v) {
-  assert(v != NULL);
-  return v->size;
+/*** vector_size **************************************************************/
+int vector_size(VECTOR *v)
+{
+    assert(v != NULL);
+    return v->size;
 }
 
-/* nice thing about file descriptors is that we are assured by POSIX 
+/*** vector_insert*************************************************************
+ * nice thing about file descriptors is that we are assured by POSIX 
  * that they are monotonically increasing.
  */
-int vector_insert(VECTOR *v, int key, PPTP_CALL * call) {
-  int i;
-  assert(v!=NULL && call != NULL);
-  assert(!vector_contains(v, key));
+int vector_insert(VECTOR *v, int key, PPTP_CALL * call)
+{
+    int i;
+    assert(v != NULL && call != NULL);
+    assert(!vector_contains(v, key));
 #ifdef VECTOR_DEBUG
-  assert(v->key_max < key);
+    assert(v->key_max < key);
 #endif
-
-  if (!(v->size < v->alloc)) {
-    void *tmp = realloc(v->item, sizeof(*(v->item)) * 2 * v->alloc);
-    if (tmp!=NULL) {
-      v->alloc *=2;
-      v->item = tmp;
-    } else return FALSE; /* failed to alloc memory. */
-  }
-  assert(v->size < v->alloc);
-  
-  /* for safety, we make this work in the general case;
-   * but this is optimized for adding call to the end of the vector.
-   */
-  for(i=v->size-1; i>=0; i--)
-    if (v->item[i].key < key)
-      break;
-  /* insert after item i */
-  memmove(&v->item[i+2], &v->item[i+1], (v->size-i-1)*sizeof(*(v->item)));
-  v->item[i+1].key  = key;
-  v->item[i+1].call = call;
-  v->size++;
-
+    if (!(v->size < v->alloc)) {
+        void *tmp = realloc(v->item, sizeof(*(v->item)) * 2 * v->alloc);
+        if (tmp != NULL) {
+            v->alloc *= 2;
+            v->item = tmp;
+        } else return FALSE; /* failed to alloc memory. */
+    }
+    assert(v->size < v->alloc);
+    /* for safety, we make this work in the general case;
+     * but this is optimized for adding call to the end of the vector.
+     */
+    for(i = v->size - 1; i >= 0; i--)
+        if (v->item[i].key < key)
+            break;
+    /* insert after item i */
+    memmove(&v->item[i + 2], &v->item[i + 1],
+            (v->size - i - 1) * sizeof(*(v->item)));
+    v->item[i + 1].key  = key;
+    v->item[i + 1].call = call;
+    v->size++;
 #ifdef VECTOR_DEBUG
-  if (v->key_max < key) /* ie, always. */
-    v->key_max = key;
+    if (v->key_max < key) /* ie, always. */
+        v->key_max = key;
 #endif
-  
-  return TRUE;
+    return TRUE;
 }
 
-int  vector_remove(VECTOR *v, int key) {
-  struct vector_item *tmp;
-  assert(v);
-
-  if ((tmp=binary_search(v,key)) == NULL) return FALSE;
-  assert(tmp>=v->item && tmp < v->item+v->size);
-  memmove(tmp, tmp+1, (v->size-(v->item-tmp)-1)*sizeof(*(v->item)));
-  v->size--;
-  return TRUE;
-}
-int  vector_search(VECTOR *v, int key, PPTP_CALL **call) {
-  struct vector_item *tmp = binary_search(v, key);
-  if (tmp==NULL) return FALSE;
-  *call = tmp->call;
-  return TRUE;
-}
-int  vector_contains(VECTOR *v, int key) {
-  assert(v!=NULL);
-  return (binary_search(v, key)!=NULL);
+/*** vector_remove ************************************************************/
+int  vector_remove(VECTOR *v, int key)
+{
+    struct vector_item *tmp;
+    assert(v != NULL);
+    if ((tmp =binary_search(v,key)) == NULL) return FALSE;
+    assert(tmp >= v->item && tmp < v->item + v->size);
+    memmove(tmp, tmp + 1, (v->size - (v->item - tmp) - 1) * sizeof(*(v->item)));
+    v->size--;
+    return TRUE;
 }
 
-static struct vector_item *binary_search(VECTOR *v, int key) {
-  int l,r,x;
-  assert(v!=NULL);
-  l = 0;  r = v->size - 1;
+/*** vector_search ************************************************************/
+int  vector_search(VECTOR *v, int key, PPTP_CALL **call)
+{
+    struct vector_item *tmp;
+    assert(v != NULL);
+    tmp = binary_search(v, key);
+    if (tmp ==NULL) return FALSE;
+    *call = tmp->call;
+    return TRUE;
+}
 
-  while (r >= l) {
-    x = (l+r)/2;
-    if (key <  v->item[x].key) r = x - 1; else l = x + 1;
-    if (key == v->item[x].key) return &(v->item[x]);
-  }
-  return NULL;
+/*** vector_contains **********************************************************/
+int  vector_contains(VECTOR *v, int key)
+{
+    assert(v != NULL);
+    return (binary_search(v, key) != NULL);
+}
+
+/*** vector_item **************************************************************/
+static struct vector_item *binary_search(VECTOR *v, int key)
+{
+    int l,r,x;
+    l = 0;
+    r = v->size - 1;
+    while (r >= l) {
+        x = (l + r)/2;
+        if (key <  v->item[x].key) r = x - 1; else l = x + 1;
+        if (key == v->item[x].key) return &(v->item[x]);
+    }
+    return NULL;
 }
 
-/* Hmm.  Let's be fancy and use a binary search for the first
+/*** vector_scan ***************************************************************
+ * Hmm.  Let's be fancy and use a binary search for the first
  * unused key, taking advantage of the list is stored sorted; ie
  * we can look at pointers and keys at two different locations, 
  * and if (ptr1 - ptr2) = (key1 - key2) then all the slots
@@ -149,46 +161,49 @@
  * never be greater than key1-key2 (no duplicate keys!)... we
  * check for this.
  */
-int vector_scan(VECTOR *v, int lo, int hi, int *key) {
-  int l,r,x;
-  assert(v!=NULL);  assert(key!=NULL);
-
-  if ((v->size<1) || (lo < v->item[0].key)) { *key = lo; return TRUE; }
-
-  /* our array bounds */
-  l = 0;  r = v->size - 1;
-
-  while (r > l) {
-    /* check for a free spot right after l */
-    if (v->item[l].key + 1 < v->item[l+1].key) { /* found it! */
-      *key = v->item[l].key + 1;
-      return TRUE;
+int vector_scan(VECTOR *v, int lo, int hi, int *key)
+{
+    int l,r,x;
+    assert(v != NULL);
+    assert(key != NULL);
+    if ((v->size<1) || (lo < v->item[0].key)) { *key = lo; return TRUE; }
+    /* our array bounds */
+    l = 0;  r = v->size - 1;
+    while (r > l) {
+        /* check for a free spot right after l */
+        if (v->item[l].key + 1 < v->item[l + 1].key) { /* found it! */
+            *key = v->item[l].key + 1;
+            return TRUE;
+        }
+        /* no dice. Let's see if the free spot is before or after the midpoint */
+        x = (l + r)/2;
+        /* Okay, we have right (r), left (l) and the probe (x). */
+        assert(x - l <= v->item[x].key - v->item[l].key);
+        assert(r - x <= v->item[r].key - v->item[x].key);
+        if (x - l < v->item[x].key - v->item[l].key)
+            /* room between l and x */
+            r = x;
+        else /* no room between l and x */
+            if (r - x < v->item[r].key - v->item[x].key)
+                /* room between x and r */
+                l = x;
+            else /* no room between x and r, either */
+                break; /* game over, man. */
     }
-    /* no dice.  Let's see if the free spot is before or after the midpoint */
-    x = (l+r)/2;
-    /* Okay, we have right (r), left (l) and the probe (x). */
-    assert(x-l <= v->item[x].key-v->item[l].key);
-    assert(r-x <= v->item[r].key-v->item[x].key);
-    if (x-l < v->item[x].key - v->item[l].key) /* room between l and x */
-      r = x;
-    else /* no room between l and x */
-      if (r-x < v->item[r].key - v->item[x].key) /* room between x and r */
-	l = x;
-      else /* no room between x and r, either */
-	break; /* game over, man. */
-  }
-  /* no room found in already allocated space.  Check to see if
-   * there's free space above allocated entries. */
-  if (v->item[v->size-1].key < hi) {
-    *key = v->item[v->size-1].key+1;
-    return TRUE;
-  }
-  /* outta luck */
-  return FALSE;
+    /* no room found in already allocated space.  Check to see if
+     * there's free space above allocated entries. */
+    if (v->item[v->size - 1].key < hi) {
+        *key = v->item[v->size - 1].key + 1;
+        return TRUE;
+    }
+    /* outta luck */
+    return FALSE;
 }
 
-PPTP_CALL * vector_get_Nth(VECTOR *v, int n) {
-  assert(v != NULL);
-  assert(0 <= n && n < vector_size(v));
-  return v->item[n].call;
+/*** vector_get_Nth ***********************************************************/
+PPTP_CALL * vector_get_Nth(VECTOR *v, int n)
+{
+    assert(v != NULL);
+    assert(0 <= n && n < vector_size(v));
+    return v->item[n].call;
 }
diff -Naur tomato/release/src/router/pptp-client/vector.h tomato121/release/src/router/pptp-client/vector.h
--- tomato/release/src/router/pptp-client/vector.h	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/vector.h	2008-04-22 21:44:06.000000000 +1000
@@ -2,7 +2,7 @@
  *                efficiently.
  *                C. Scott Ananian <cananian@alumni.princeton.edu>
  *
- * $Id: vector.h,v 1.1.1.1 2002/07/25 06:52:39 honor Exp $
+ * $Id: vector.h,v 1.1.1.1 2000/12/23 08:19:51 scott Exp $
  */
 
 #ifndef INC_VECTOR_H
diff -Naur tomato/release/src/router/pptp-client/vector_test.c tomato121/release/src/router/pptp-client/vector_test.c
--- tomato/release/src/router/pptp-client/vector_test.c	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/vector_test.c	2008-04-22 21:44:06.000000000 +1000
@@ -1,7 +1,7 @@
 /* vector_test.c .... Test the vector package.
  *                    C. Scott Ananian <cananian@alumni.princeton.edu>
  *
- * $Id: vector_test.c,v 1.1.1.1 2002/07/25 06:52:39 honor Exp $
+ * $Id: vector_test.c,v 1.2 2003/06/17 17:25:47 reink Exp $
  */
 
 #include <stdlib.h>
@@ -11,84 +11,84 @@
 #define MAX 25
 
 void main(void) {
-  int i, j, retval;
+    int i, j, retval;
 
-  VECTOR *v = vector_create();
-  assert(v != NULL);
-  assert(vector_size(v)==0);
-  for (i=0; i<=MAX; i++) {
-    assert(!vector_contains(v, i));
-    assert(!vector_remove(v, i));
-    assert(!vector_search(v, i, (PPTP_CALL **)&j));
-    retval = vector_scan(v, i, MAX*2, &j);
-    assert(retval);
-    assert(j==i);
-  }
+    VECTOR *v = vector_create();
+    assert(v != NULL);
+    assert(vector_size(v)==0);
+    for (i=0; i<=MAX; i++) {
+        assert(!vector_contains(v, i));
+        assert(!vector_remove(v, i));
+        assert(!vector_search(v, i, (PPTP_CALL **)&j));
+        retval = vector_scan(v, i, MAX*2, &j);
+        assert(retval);
+        assert(j==i);
+    }
+
+    for (i=1; i<=MAX; i++) {
+        retval = vector_insert(v, i, (PPTP_CALL *)i);
+        assert(retval);
+        assert(vector_size(v)==i);
+    }
+    for (i=1; i<MAX; i++) {
+        retval = vector_search(v, i, (PPTP_CALL **)&j);
+        assert(retval);
+        assert(j==i);
+        retval = vector_contains(v, i);
+        assert(retval);
+    }
+    assert(vector_size(v)==MAX);
+    retval = vector_contains(v, MAX+1);
+    assert(!retval);
+    retval = vector_search(v, MAX+1, (PPTP_CALL **)&j);
+    assert(!retval);
 
-  for (i=1; i<=MAX; i++) {
-    retval = vector_insert(v, i, (PPTP_CALL *)i);
-    assert(retval);
-    assert(vector_size(v)==i);
-  }
-  for (i=1; i<MAX; i++) {
-    retval = vector_search(v, i, (PPTP_CALL **)&j);
-    assert(retval);
-    assert(j==i);
-    retval = vector_contains(v, i);
-    assert(retval);
-  }
-  assert(vector_size(v)==MAX);
-  retval = vector_contains(v, MAX+1);
-  assert(!retval);
-  retval = vector_search(v, MAX+1, (PPTP_CALL **)&j);
-  assert(!retval);
-
-  retval = vector_scan(v, 0, MAX, &j);
-  assert(retval);
-  assert(j==0);
-  retval = vector_scan(v, 1, MAX, &j);
-  assert(!retval);
-  retval = vector_scan(v, 1, MAX+1, &j);
-  assert(retval);
-  assert(j==MAX+1);
-  retval = vector_scan(v, 1, MAX+MAX, &j);
-  assert(retval);
-  assert(j==MAX+1);
-
-  for (i=0; i<(MAX*10); i++) {
-    int k = (random() % MAX) + 1;
-    assert(vector_contains(v, k));
-    assert(!vector_scan(v, 1, k, &j));
-    assert(!vector_scan(v, k, MAX, &j));
-    retval = vector_remove(v, k);
+    retval = vector_scan(v, 0, MAX, &j);
     assert(retval);
-    assert(vector_size(v)==MAX-1);
-    assert(!vector_contains(v, k));
-    assert(!vector_search(v, k, (PPTP_CALL **) &j));
+    assert(j==0);
     retval = vector_scan(v, 1, MAX, &j);
+    assert(!retval);
+    retval = vector_scan(v, 1, MAX+1, &j);
     assert(retval);
-    assert(j==k);
-    retval = vector_insert(v, k, (PPTP_CALL *) k);
-    assert(retval);
-    assert(vector_size(v)==MAX);
-    assert(vector_contains(v, k));
-    assert(!vector_scan(v, 1, MAX, &j));
-    retval = vector_search(v, k, (PPTP_CALL **) &j);
+    assert(j==MAX+1);
+    retval = vector_scan(v, 1, MAX+MAX, &j);
     assert(retval);
-    assert(j==k);
-  }
+    assert(j==MAX+1);
 
-  for (i=1; i<=MAX; i++) {
-    assert(vector_size(v)==MAX-(i-1));
-    vector_remove(v, i);
-    assert(vector_size(v)==MAX-i);
-    assert(!vector_contains(v, i));
-    retval = vector_search(v, i, (PPTP_CALL **) &j);
-    assert(!retval);
-    retval = vector_scan(v, 1, MAX, &j);
-    assert(retval);
-    assert(j==1);
-  }
-  assert(vector_size(v)==0);
-  vector_destroy(v);
+    for (i=0; i<(MAX*10); i++) {
+        int k = (random() % MAX) + 1;
+        assert(vector_contains(v, k));
+        assert(!vector_scan(v, 1, k, &j));
+        assert(!vector_scan(v, k, MAX, &j));
+        retval = vector_remove(v, k);
+        assert(retval);
+        assert(vector_size(v)==MAX-1);
+        assert(!vector_contains(v, k));
+        assert(!vector_search(v, k, (PPTP_CALL **) &j));
+        retval = vector_scan(v, 1, MAX, &j);
+        assert(retval);
+        assert(j==k);
+        retval = vector_insert(v, k, (PPTP_CALL *) k);
+        assert(retval);
+        assert(vector_size(v)==MAX);
+        assert(vector_contains(v, k));
+        assert(!vector_scan(v, 1, MAX, &j));
+        retval = vector_search(v, k, (PPTP_CALL **) &j);
+        assert(retval);
+        assert(j==k);
+    }
+
+    for (i=1; i<=MAX; i++) {
+        assert(vector_size(v)==MAX-(i-1));
+        vector_remove(v, i);
+        assert(vector_size(v)==MAX-i);
+        assert(!vector_contains(v, i));
+        retval = vector_search(v, i, (PPTP_CALL **) &j);
+        assert(!retval);
+        retval = vector_scan(v, 1, MAX, &j);
+        assert(retval);
+        assert(j==1);
+    }
+    assert(vector_size(v)==0);
+    vector_destroy(v);
 }
diff -Naur tomato/release/src/router/pptp-client/version.c tomato121/release/src/router/pptp-client/version.c
--- tomato/release/src/router/pptp-client/version.c	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/version.c	2008-04-22 21:44:06.000000000 +1000
@@ -1,8 +1,8 @@
 /* version.c ..... keep track of package version number. 
  *                 C. Scott Ananian <cananian@alumni.princeton.edu>
  *
- * $Id: version.c,v 1.1.1.1 2002/07/25 06:52:39 honor Exp $
+ * $Id: version.c,v 1.3 2004/06/22 09:52:26 quozl Exp $
  */
 
 #include "config.h"
-const char * version = "pptp-linux version " PPTP_LINUX_VERSION;
+const char * version = "pptp version " PPTP_LINUX_VERSION;
diff -Naur tomato/release/src/router/pptp-client/version.h tomato121/release/src/router/pptp-client/version.h
--- tomato/release/src/router/pptp-client/version.h	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pptp-client/version.h	2008-04-22 21:44:06.000000000 +1000
@@ -1,7 +1,7 @@
 /* version.h ..... keep track of package version number. 
  *                 C. Scott Ananian <cananian@alumni.princeton.edu>
  *
- * $Id: version.h,v 1.1.1.1 2002/07/25 06:52:39 honor Exp $
+ * $Id: version.h,v 1.1.1.1 2000/12/23 08:19:51 scott Exp $
  */
 
 #ifndef INC_VERSION_H
